DELETE FROM report_sql WHERE computer={?Computer};

DELETE FROM ex_post WHERE computer={?Computer};

INSERT INTO ex_post (COMPUTER, 
                     ID_LETNI_DONOS, 
                     TIP,	
                     DAN, IDPOG, 
                     SFVP,	
                     ZAC_STANJE,	
                     VRD_STANJE, 
                     PROM,
                     PROM_LOT,
                     PROM_VPL,
                     PROM_IZPL)
SELECT {?Computer}, ID_EX_POST_SEQ.nextval, POD.* FROM (
-- zaetno stanje VP
SELECT '1' tip, V.Dan dan, V.IdPog idpog, V.SfVp sfvp, 
       v.lot*(v.glv+v.obr) zac_stanje, 
       v.lot*(v.glv+v.obr) vrd_stanje, 
       0 prom,
       0 prom_lot,
       0 prom_vpl,
       0 prom_izpl
FROM vpshst V
WHERE V.dan = {?DanOd}
AND V.SfSvp='L'
AND V.SfLst <> 'G'
AND V.SfDjv IN ('N', 'U')
? AND V.SfDjv = {?Dejavnost}
? AND v.idpog = {?Pogodba}
UNION ALL
-- transakcije 
SELECT '2' tip, D.Dan, D.Idpog, D.SfVp, 0 zac_stanje, 0 vrd_stanje,
       sum((CASE WHEN NVL(D.GLVTCJ,0) = 0 THEN CASE WHEN D.sfglvent ='%' THEN d.vp*(nvl(ibi_utils.GetTcn(D.sfvp, d.dan),0)/100*(SELECT glv FROM kpn WHERE sfvp=D.sfvp AND sfkpn=(SELECT max(sfkpn) FROM kpn WHERE sfvp=d.sfvp and prvdantrg <= D.Dan))+D.OBRVLT+D.REVVLT)
                                                                    ELSE d.vp*(nvl(ibi_utils.GetTcn(D.sfvp, D.dan),0)) END
                                     ELSE d.vp*(D.GLVVLT+D.OBRVLT+D.REVVLT)
       END)/ CASE WHEN (nvl(D.tcjvlt,0)=0 OR D.sfvlt='E') THEN 1 ELSE D.tcjvlt END) prom,
       sum(d.vp) prom_lot,
       (SELECT sum((CASE WHEN NVL(D1.GLVTCJ,0) = 0 THEN CASE WHEN D1.sfglvent ='%' THEN d1.vp*(nvl(ibi_utils.GetTcn(D1.sfvp, d1.dan),0)/100*(SELECT glv FROM kpn WHERE sfvp=D1.sfvp AND sfkpn=(SELECT max(sfkpn) FROM kpn WHERE sfvp=d1.sfvp and prvdantrg <= D1.Dan))+D1.OBRVLT+D1.REVVLT)
                                                                    ELSE d1.vp*(nvl(ibi_utils.GetTcn(D1.sfvp, D1.dan),0)) END
                                     ELSE d1.vp*(D1.GLVVLT+D1.OBRVLT+D1.REVVLT)
       END)/ CASE WHEN (nvl(D1.tcjvlt,0)=0 OR D1.sfvlt='E') THEN 1 ELSE D1.tcjvlt END)
       FROM dog d1 WHERE d1.dan=d.dan AND d1.sfdjv=d.sfdjv AND d1.idpog=d.idpog AND d1.sfvp=d.sfvp and d1.vp >= 0) prom_vpl,
       (SELECT sum((CASE WHEN NVL(D1.GLVTCJ,0) = 0 THEN CASE WHEN D1.sfglvent ='%' THEN d1.vp*(nvl(ibi_utils.GetTcn(D1.sfvp, d1.dan),0)/100*(SELECT glv FROM kpn WHERE sfvp=D1.sfvp AND sfkpn=(SELECT max(sfkpn) FROM kpn WHERE sfvp=d1.sfvp and prvdantrg <= D1.Dan))+D1.OBRVLT+D1.REVVLT)
                                                                    ELSE d1.vp*(nvl(ibi_utils.GetTcn(D1.sfvp, D1.dan),0)) END
                                     ELSE d1.vp*(D1.GLVVLT+D1.OBRVLT+D1.REVVLT)
       END)/ CASE WHEN (nvl(D1.tcjvlt,0)=0 OR D1.sfvlt='E') THEN 1 ELSE D1.tcjvlt END)
       FROM dog d1 WHERE d1.dan=d.dan AND d1.sfdjv=d.sfdjv AND d1.idpog=d.idpog AND d1.sfvp=d.sfvp and d1.vp < 0) prom_izpl
FROM dog D
WHERE D.Dan > {?DanOd} AND D.Dan <= {?DanDo}
AND D.VP <> 0
AND D.SfDjv IN ('N', 'U')
? AND D.SfDjv = {?Dejavnost}
? AND D.idpog = {?Pogodba}
GROUP BY D.Dan, D.SfDjv, D.Idpog, D.SfVp
UNION ALL
-- konno stanje
SELECT '3' tip, V.Dan dan, V.IdPog idpog, V.SfVp sfvp, 
       0 zac_stanje, 
       v.lot*(v.glv+v.obr) vrd_stanje, 
       0 prom,
       v.lot prom_lot,
       0 prom_vpl,
       0 prom_izpl
FROM vpshst V
WHERE V.dan = {?DanDo}
AND V.SfSvp='L'
AND V.SfDjv IN ('N', 'U')
AND V.SfLst <> 'G'
? AND V.SfDjv = {?Dejavnost}
? AND V.idpog = {?Pogodba}
) POD;

-- zaetno stanje VP za pogodbe brez vrednotenja na dan_od
INSERT INTO ex_post (COMPUTER,
ID_LETNI_DONOS,
TIP,
DAN, IDPOG,
SFVP,
ZAC_STANJE,
VRD_STANJE,
PROM,
PROM_LOT,
PROM_VPL,
PROM_IZPL)
SELECT {?Computer}, ID_EX_POST_SEQ.nextval, '1', {?DanOd}, pod.*, 0,null,0,0,0,0 FROM (
SELECT d.idpog, d.sfvp
FROM DOG d
JOIN sfvp s ON s.sfvp=d.sfvp
WHERE d.dan <= {?DanOd} and d.idobd=2
AND (SELECT count(*) FROM ex_post e WHERE e.tip='1' and e.idpog=d.idpog and e.sfvp=d.sfvp) = 0
AND D.SfDjv IN ('N', 'U')
? AND D.SfDjv = {?Dejavnost}
? AND D.idpog = {?Pogodba}
GROUP BY d.idpog, d.sfvp, s.krt
HAVING sum (d.VP) <> 0
) POD;

-- konno stanje VP za pogodbe brez vrednotenja na dan_do
INSERT INTO ex_post (COMPUTER,
ID_LETNI_DONOS,
TIP,
DAN, IDPOG,
SFVP,
ZAC_STANJE,
VRD_STANJE,
PROM,
PROM_LOT,
PROM_VPL,
PROM_IZPL)
SELECT {?Computer}, ID_EX_POST_SEQ.nextval, '3', {?DanDo}, pod.*, 0,null,0,
(SELECT sum(d.vp) FROM dog d where d.idpog=pod.idpog AND d.sfvp=pod.sfvp AND d.dan <= {?DanDo} and d.idobd=2),
0,0 FROM (
SELECT distinct e1.idpog, e1.sfvp
FROM ex_post e1
WHERE e1.tip='2'
AND (SELECT count(*) FROM ex_post e2 WHERE e2.tip='3' and e2.idpog=e1.idpog and e2.sfvp=e1.sfvp) = 0
UNION
SELECT d.idpog, d.sfvp
FROM DOG d
JOIN sfvp s ON s.sfvp=d.sfvp
WHERE d.dan <= {?DanDo} and d.idobd=2
AND (SELECT count(*) FROM ex_post e WHERE e.tip='3' and e.idpog=d.idpog and e.sfvp=d.sfvp) = 0
AND D.SfDjv IN ('N', 'U')
? AND D.SfDjv = {?Dejavnost}
? AND D.idpog = {?Pogodba}
GROUP BY d.idpog, d.sfvp, s.krt
HAVING sum (d.VP) <> 0
) POD;

COMMIT;

INSERT INTO report_sql (computer, num1) SELECT {?Computer}, EX_POST_FUNCT({?Computer}) FROM DUAL;
DELETE FROM report_sql WHERE computer={?Computer};

COMMIT;

INSERT INTO REPORT_SQL (computer, 
                        str1,  -- 1=ex_post, 2=stroski_skupaj
                        date1, -- datum_od
                        date2, -- datum_od
                        num1,  -- idpog
                        num2,  -- sfvp
                        num3,  -- zacetno stanje
                        num4,  -- promet
                        num5,  -- koncno stanje
                        num6,  -- donos EUR brez stroskov
                        num7,  -- donos % brez stroskov
                        num8,  -- stroski EUR
                        num9,  -- stroski %
                        num10, -- donos EUR s stroski
                        num11, -- donos % s stroski
                        num12, -- tevilo kotacij na org. trgu
                        num13, -- promet vplaila
                        num14) -- promet izplaila
SELECT ex.computer, 
       '1',
       {?DanOd},
       {?DanDo},
       ex.idpog, 
       ex.sfvp,
       (SELECT zac_stanje FROM ex_post ex1 WHERE ex.idpog=ex1.idpog AND ex.sfvp=ex1.sfvp 
        AND dan=(SELECT min(dan) FROM ex_post ex2 WHERE ex1.idpog=ex2.idpog AND ex1.sfvp=ex2.sfvp)) zac,
       sum(ex.prom) prom,
       (SELECT vrd_stanje FROM ex_post ex1 WHERE ex.idpog=ex1.idpog AND ex.sfvp=ex1.sfvp 
        AND dan=(SELECT max(dan) FROM ex_post ex2 WHERE ex1.idpog=ex2.idpog AND ex1.sfvp=ex2.sfvp)) kon,
       sum(ex.donos_b_eur) donos_b,
       (SELECT donos_b_koncni FROM ex_post ex1 WHERE ex.idpog=ex1.idpog AND ex.sfvp=ex1.sfvp 
        AND dan=(SELECT max(dan) FROM ex_post ex2 WHERE ex1.idpog=ex2.idpog AND ex1.sfvp=ex2.sfvp)) donos_b_proc,
       sum(ex.stroski) stroski,
       (SELECT stroski_proc FROM ex_post ex1 WHERE ex.idpog=ex1.idpog AND ex.sfvp=ex1.sfvp 
        AND dan=(SELECT max(dan) FROM ex_post ex2 WHERE ex1.idpog=ex2.idpog AND ex1.sfvp=ex2.sfvp)) stroski_proc,
       sum(ex.donos_s_eur) donos_s,
       (SELECT donos_s_koncni FROM ex_post ex1 WHERE ex.idpog=ex1.idpog AND ex.sfvp=ex1.sfvp 
        AND dan=(SELECT max(dan) FROM ex_post ex2 WHERE ex1.idpog=ex2.idpog AND ex1.sfvp=ex2.sfvp)) donos_s_proc,
       (CASE WHEN ex.sfvp in (7814,3518,5440,7924,8597) THEN 1 ELSE nvl((SELECT count(*) FROM ktc k JOIN trg t ON k.sftrg=t.sftrg 
        WHERE ex.sfvp=k.sfvp AND(k.danprk is null OR k.danprk > {?DanOd}) and k.dan <={?DanOd} and t.sftrz='2'),1) END) st_org,
       sum(ex.prom_vpl) prom_vpl,
       sum(ex.prom_izpl) prom_izpl
FROM ex_post ex
WHERE ex.computer={?Computer}
GROUP BY ex.computer, ex.idpog, ex.sfvp;

INSERT INTO REPORT_SQL (computer, 
                        str1,  -- 1=ex_post, 2=stroski_skupaj
                        num1,  -- idpog
                        num18, -- stroski skupaj
                        num19, -- vplacila VP skupaj
                        num20, -- izplacila VP skupaj
                        num21, -- vplacila got skupaj
                        num22) -- izplacila got skupaj
SELECT {?Computer},
       '2',
       ex.idpog,
       (nvl((SELECT sum(D.lot) FROM dog D WHERE D.idpog=ex.idpog AND D.dan between {?DanOd} AND {?DanDo} AND D.sfpdg='S' AND D.stn IS NULL),0)) +
       (nvl((SELECT sum(D.lot) FROM dog D WHERE D.idpog=ex.idpog AND D.dan between {?DanOd} AND {?DanDo} AND D.sfpdg='$' AND D.brezsto='D'),0)),
       nvl((SELECT round(nvl(sum((CASE WHEN NVL(D.GLVTCJ,0) = 0 THEN CASE WHEN D.sfglvent ='%' THEN d.vp*(nvl(ibi_utils.GetTcn(D.sfvp, d.dan),0)/100*(SELECT glv FROM kpn WHERE sfvp=D.sfvp AND sfkpn=(SELECT max(sfkpn) FROM kpn WHERE sfvp=d.sfvp and prvdantrg <= D.Dan))+D.OBRVLT+D.REVVLT)
       ELSE d.vp*(nvl(ibi_utils.GetTcn(D.sfvp, D.dan),0)) END
       ELSE d.vp*(D.GLVVLT+D.OBRVLT+D.REVVLT)
       END)/ CASE WHEN (nvl(D.tcjvlt,0)=0 OR D.sfvlt='E') THEN 1 ELSE D.tcjvlt END),0),2) FROM dog D WHERE D.idpog=ex.idpog AND D.dan between {?DanOd} AND {?DanDo} AND D.vp > 0),0),
       nvl((SELECT round(nvl(sum((CASE WHEN NVL(D.GLVTCJ,0) = 0 THEN CASE WHEN D.sfglvent ='%' THEN d.vp*(nvl(ibi_utils.GetTcn(D.sfvp, d.dan),0)/100*(SELECT glv FROM kpn WHERE sfvp=D.sfvp AND sfkpn=(SELECT max(sfkpn) FROM kpn WHERE sfvp=d.sfvp and prvdantrg <= D.Dan))+D.OBRVLT+D.REVVLT)
       ELSE d.vp*(nvl(ibi_utils.GetTcn(D.sfvp, D.dan),0)) END
       ELSE d.vp*(D.GLVVLT+D.OBRVLT+D.REVVLT)
       END)/ CASE WHEN (nvl(D.tcjvlt,0)=0 OR D.sfvlt='E') THEN 1 ELSE D.tcjvlt END),0),2) FROM dog D WHERE D.idpog=ex.idpog AND D.dan between {?DanOd} AND {?DanDo} AND D.vp < 0),0),
       nvl((SELECT round(sum(d.got/ CASE WHEN (nvl(D.tcjvlt,0)=0 OR D.sfvlt='E') THEN 1 ELSE D.tcjvlt END),2) FROM dog D WHERE D.idpog=ex.idpog AND D.dan between {?DanOd} AND {?DanDo} AND D.got > 0),0),
       nvl((SELECT round(sum(d.got/ CASE WHEN (nvl(D.tcjvlt,0)=0 OR D.sfvlt='E') THEN 1 ELSE D.tcjvlt END),2) FROM dog D WHERE D.idpog=ex.idpog AND D.dan between {?DanOd} AND {?DanDo} AND D.got < 0),0)
FROM ex_post ex
WHERE ex.computer={?Computer}
GROUP BY ex.computer, ex.idpog;


